Attribute VB_Name = "SimonCarter_WindowsLibraryAll"
Option Explicit

Public Const ID_YES = 6
Public Const ID_Cancel = 2
Public Const ID_No = 7


Public Const DBFilter = "Database Files (*.MDB)|*.mdb"
Public Const AllFilter = "All Files (*.*)|*.*"
Public Const ExeFilter = "Executable Files (*.EXE)|*.exe"
Public Win95RegBase As String
#If Win32 Then
    'SCWL Functions
    
    'Under Construction
    Declare Function KeyStat Lib "scwl32.dll" (ByVal KeyToCheck As Integer) As Integer
    Global Const KeyStatErr = -10 'could not map keyboard
    Global Const KeyStatIsOn = 2 'key is currently on
    Global Const KeyStatIsOff = 1 'Key is currently Off
    Global Const KeyStatNumLock = 90
    Global Const KeyStatCapsLock = 14
    Global Const KeyStatScrollLock = 91
    
    
    Declare Function Battery Lib "scwl32.dll" (ByVal BatteryType As Long) As Long
    
    'Battery Type Consts
    Public Const BatteryPowerStatus = 1
    Public Const BatteryChargeStatus = 2
    Public Const BatteryLifePercent = 3
    Public Const BatteryLifeTime = 4
    Public Const BatteryFullLifeTime = 5
    
    'Result Type Consts
    Public Const BatteryNoInformation = -1
    Public Const BatteryInvalidBatteryType = -2
    Public Const BatteryErrorInDLL = -3
   
    
    
    Declare Function AscWP Lib "scwl32.dll" (ByVal Str As String, Pos As Integer) As Long
    'End Under Construction
    
    Declare Function LoggedOn Lib "scwl32.dll" (ByRef Name As String) As Integer
    
    
    Declare Function SCFont Lib "scwl32.dll" (ByRef ThisFont As SCFontStruct) As Integer
    Declare Function ProperString Lib "scwl32.dll" (ByRef S As String) As Integer
    Declare Function GetDirStruct Lib "scwl32.dll" (ByVal Dir As Integer, ListBoxHandle As Integer) As Integer
    Declare Function Soundalike Lib "scwl32.dll" Alias "SoundAlikeA" (ByVal S1 As String, ByVal S2 As String) As Boolean
    Declare Function PentiumBug Lib "scwl32.dll" Alias "PentiumBugA" () As Boolean
    'Return Comm Ports Available
    'Declare Function CommPorts Lib "scwl32.dll" () As Integer 'not available 32 Bit (Yet)
        'CommPorts will be combination of following
    'Comm 1 = 1
    'Comm 2 = 2
    'Comm 3 = 4
    'Comm 4 = 8
    'No comm Ports = 0
    
    'GetHiB & GetLoB Gets The hi and lo bytes from a word
    'Word    0  ..  65535    Unsigned 16-bit (Type of Long Integer)
    Declare Function GetHiB Lib "scwl32.dll" Alias "GetHiBA" (ByVal GetFrom As Integer) As Byte
    Declare Function GetLoB Lib "scwl32.dll" Alias "GetLoBA" (ByVal GetFrom As Integer) As Byte
    
    'GetHiW & GetLoW Gets The hi and lo Words from an Integer
    Declare Function GetHiW Lib "scwl32.dll" Alias "GetHiWA" (ByVal GetFrom As Long) As Integer
    Declare Function GetLoW Lib "scwl32.dll" Alias "GetLoWA" (ByVal GetFrom As Long) As Integer
    
    Declare Function CursorN Lib "scwl32.dll" Alias "CursorNA" () As Integer
    Declare Function CursorH Lib "scwl32.dll" Alias "CursorHA" () As Integer
    'No Longer Supported Declare Sub DispMsg Lib "scwl32.dll" Alias "DispMsgA" (ByVal Title As String, ByVal filename As String)
    Declare Function ShowTips Lib "scwl32.dll" Alias "ShowTipsA" (ByVal Title As String, ByVal TipTitle As String, ByVal StringFile As String, ByVal ShowAtStart As Integer) As Integer
    Declare Sub OpenCD Lib "scwl32.dll" Alias "OpenCDA" ()
    Declare Function EditOption Lib "scwl32.dll" Alias "EditOptionA" () As Integer
    Declare Function GetTime Lib "scwl32.dll" Alias "GetTimeA" (RtnTime As String) As Integer
    Declare Function GetPath Lib "scwl32.dll" Alias "GetPathA" (rtnpath As String) As Integer
    Declare Function ShowAbout Lib "scwl32.dll" Alias "showaboutA" (ByVal IcoFile As String, ByVal Title As String, ByVal Version As String) As Boolean
    Declare Function ShowOpen Lib "scwl32.dll" Alias "FOpen" (ByVal Title As String, ByVal Filter As String, ByVal DefaultDir As String, ReturnFile As String) As Integer
    Declare Function ShowSave Lib "scwl32.dll" Alias "FSave" (ByVal Title As String, ByVal Filter As String, ByVal DefaultDir As String, ReturnFile As String) As Integer
    
    Declare Function GetSymbol Lib "scwl32.dll" Alias "GetSymbolA" () As Boolean
    Declare Function GetColor Lib "scwl32.dll" Alias "GetColorA" () As Long
    Declare Sub ShowDisk Lib "scwl32.dll" Alias "ShowDiskA" ()
    Declare Function GetDate Lib "scwl32.dll" Alias "GetDateA" (ByRef rtndate As String) As Integer
    'No Longer Supported Declare Function GetDateI Lib "scwl32.dll" Alias "GetDateIA" () As Long
    Declare Function GetHwnd Lib "scwl32.dll" Alias "GetHwndA" (ByVal MHwnd As Integer, ByVal WindowTitle As String) As Integer
    Declare Function MemTotal Lib "scwl32.dll" Alias "MemTotalA" () As Long
    Declare Function MemFree Lib "scwl32.dll" Alias "MemFreeA" () As Long
    Declare Sub WrapCursor Lib "scwl32.dll" Alias "WrapCursorA" ()
    Declare Function Percent Lib "scwl32.dll" Alias "PercentA" (ByVal Num As Double, ByVal Total As Double) As Integer
    Declare Sub Today Lib "scwl32.dll" Alias "TodayA" (RtnDay As String)
    Declare Function ChangeTitle Lib "scwl32.dll" Alias "ChangeTitleA" (ByVal MHwnd As Integer, ByVal ExistTitle As String, ByVal newtitle As String) As Integer
    Declare Function ActiveTitle Lib "scwl32.dll" Alias "ActiveTitleA" (returntitle As String) As Integer
    Declare Sub SetActiveTitle Lib "scwl32.dll" Alias "SetActiveTitleA" (ByVal returntitle As String)
    Declare Sub CloseWindows Lib "scwl32.dll" Alias "ExitWinA" (ByVal ExitStyle As Integer)
    Declare Function Logon Lib "scwl32.dll" Alias "LogonA" (ByVal Title As String, ByRef RtnValue As String) As Integer
    Declare Function getini Lib "scwl32.dll" Alias "GetIniA" (ByVal Section As String, ByVal key As String, ByVal IniFile As String, default As String) As Integer
    Declare Function writeini Lib "scwl32.dll" Alias "WriteIniA" (ByVal Section As String, ByVal key As String, ByVal Setting As String, ByVal IniFile As String) As Integer
    Declare Sub OnTop Lib "scwl32.dll" Alias "OnTopA" (ByVal Hwnd As Long)
    Declare Sub NotTop Lib "scwl32.dll" Alias "NotTopA" (ByVal Hwnd As Integer)
    Declare Function Fileexist Lib "scwl32.dll" Alias "FileExistA" (ByVal filename As String) As Integer
    Declare Function ShowHelp Lib "scwl32.dll" Alias "ShowHelpA" (ByVal MHwnd As Integer, ByVal TheHelpFile As String, ByVal TopicNo As Long) As Boolean
    Declare Function Showsearch Lib "scwl32.dll" Alias "ShowSearchA" (ByVal MHwnd As Integer, ByVal TheHelpFile As String) As Boolean
    Declare Function HDFree Lib "scwl32.dll" Alias "HDFreeA" (ByVal DiskNum As Integer) As Long
    Declare Function HDUsed Lib "scwl32.dll" Alias "HDUsedA" (ByVal DiskNum As Integer) As Long
    Declare Function HDTotal Lib "scwl32.dll" Alias "HDTotalA" (ByVal DiskNum As Integer) As Long
    Declare Function CLBFind Lib "scwl32.dll" Alias "CLBFindA" (ByVal CL As Integer, ByVal Handle As Long, ByVal TextSearch As String) As Integer

    'Windows Functions
    Declare Function GetActiveWindow Lib "user32" () As Integer
    Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
    Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal Hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
    Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, lpFileName As String) As Long
    Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
    Declare Function ShowWindow Lib "user32" (ByVal Hwnd As Long, ByVal nCmdShow As Long) As Long
    Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
    Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
    Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
    Declare Function sndPlaySound Lib "WINMM.DLL" Alias "sndPlaySoundA" (ByVal lpszSoundName As Any, ByVal uFlags As Long) As Long
    Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
    Declare Function GetDC Lib "user32" (ByVal Hwnd As Long) As Long
    Declare Function ReleaseDC Lib "user32" (ByVal Hwnd As Long, ByVal hdc As Long) As Long
    Declare Function GetDesktopWindow Lib "user32" () As Long

   Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
   Private Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
   Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
   Private Const NORMAL_PRIORITY_CLASS = &H20&
   Private Const INFINITE = -1&
   Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
   Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
    Type POINTAPI       ' Stores location of cursor
        X As Long
        Y As Long
    End Type
    Public Const CB_FINDSTRING = &H14C
    Public Const LB_FINDSTRING = &H18F

#Else
    Declare Function ProperString Lib "scwl.dll" (ByRef S As String) As Integer
    Declare Function GetDirStruct Lib "scwl.dll" (ByVal Dir As Integer, ListBoxHandle As Integer) As Integer
    Declare Function Soundalike Lib "scwl.dll" (ByVal S1 As String, ByVal S2 As String) As Boolean
    Declare Function IsShareLoaded Lib "scwl.dll" () As Boolean
    Declare Function PentiumBug Lib "scwl.dll" () As Boolean
    'Return Comm Ports Available
    Declare Function CommPorts Lib "scwl.dll" () As Integer
        'CommPorts will be combination of following
    'Comm 1 = 1
    'Comm 2 = 2
    'Comm 3 = 4
    'Comm 4 = 8
    'No comm Ports = 0
    
    'GetHiB & GetLoB Gets The hi and lo bytes from a word
    'Word    0  ..  65535    Unsigned 16-bit (Type of Long Integer)
    Declare Function GetHiB Lib "scwl.dll" (ByVal GetFrom As Integer) As Byte
    Declare Function GetLoB Lib "scwl.dll" (ByVal GetFrom As Integer) As Byte
    
    'GetHiW & GetLoW Gets The hi and lo Words from an Integer
    Declare Function GetHiW Lib "scwl.dll" (ByVal GetFrom As Long) As Integer
    Declare Function GetLoW Lib "scwl.dll" (ByVal GetFrom As Long) As Integer
    
    Declare Function CursorN Lib "scwl.dll" () As Integer
    Declare Function CursorH Lib "scwl.dll" () As Integer
    Declare Sub DispMsg Lib "scwl.dll" (ByVal Title As String, ByVal filename As String)
    Declare Function ShowTips Lib "scwl.dll" Alias "Showtips" (ByVal Title As String, ByVal TipTitle As String, ByVal StringFile As String, ByVal ShowAtStart As Integer) As Integer
    Declare Sub OpenCD Lib "scwl.dll" ()
    Declare Function EditOption Lib "scwl.dll" () As Integer
    Declare Function GetTime Lib "scwl.dll" (RtnTime As String) As Integer
    Declare Function GetPath Lib "scwl.dll" (rtnpath As String) As Integer
    Declare Function ShowAbout Lib "scwl.dll" (ByVal IcoFile As String, ByVal Title As String, ByVal Version As String) As Boolean
    Declare Function ShowOpen Lib "scwl.dll" (ByVal Title As String, ByVal Filter As String, ByVal DefaultDir As String, ReturnFile As String) As Integer
    Declare Function ShowSave Lib "scwl.dll" (ByVal Title As String, ByVal Filter As String, ByVal DefaultDir As String, ReturnFile As String) As Integer
    Declare Sub ShowTip Lib "scwl.dll" (ByVal tiptext As String)
    
    Declare Function GetSymbol Lib "scwl.dll" () As Boolean
    Declare Function GetColor Lib "scwl.dll" () As Long
    Declare Sub ShowStart Lib "scwl.dll" (ByVal PictureFile As String)
    Declare Sub ClearStart Lib "scwl.dll" ()
    Declare Sub ShowRes Lib "scwl.dll" ()
    Declare Sub ShowDisk Lib "scwl.dll" ()
    Declare Function GetDate Lib "scwl.dll" (ByRef rtndate As String) As Integer
    Declare Function GetDateI Lib "scwl.dll" () As Long
    Declare Function GetHwnd Lib "scwl.dll" (ByVal MHwnd As Integer, ByVal WindowTitle As String) As Integer
    Declare Function MemTotal Lib "scwl.dll" () As Long
    Declare Function MemFree Lib "scwl.dll" () As Long
    Declare Sub WrapCursor Lib "scwl.dll" ()
    Declare Function Percent Lib "scwl.dll" (ByVal Num As Double, ByVal Total As Double) As Integer
    Declare Sub Today Lib "scwl.dll" (RtnDay As String)
    Declare Function ChangeTitle Lib "scwl.dll" Alias "changetitle" (ByVal MHwnd As Integer, ByVal ExistTitle As String, ByVal newtitle As String) As Integer
    Declare Function ActiveTitle Lib "scwl.dll" (returntitle As String) As Integer
    Declare Sub SetActiveTitle Lib "scwl.dll" (ByVal returntitle As String)
    Declare Sub CloseWindows Lib "scwl.dll" Alias "ExitWin" (ByVal ExitStyle As Integer)
    Declare Function Logon Lib "scwl.dll" (ByVal Title As String, RtnValue As String) As Integer
    Declare Function getini Lib "scwl.dll" (ByVal Section As String, ByVal key As String, ByVal IniFile As String, default As String) As Integer
    Declare Function writeini Lib "scwl.dll" (ByVal Section As String, ByVal key As String, ByVal Setting As String, ByVal IniFile As String) As Integer
    Declare Sub OnTop Lib "scwl.dll" (ByVal Hwnd As Integer)
    Declare Sub NotTop Lib "scwl.dll" (ByVal Hwnd As Integer)
    Declare Function Fileexist Lib "scwl.dll" (ByVal filename As String) As Integer
    Declare Function ShowHelp Lib "scwl.dll" (ByVal MHwnd As Integer, ByVal TheHelpFile As String, ByVal TopicNo As Long) As Boolean
    Declare Function Showsearch Lib "scwl.dll" (ByVal MHwnd As Integer, ByVal TheHelpFile As String) As Boolean
    Declare Function GetRes Lib "scwl.dll" (ByVal restype As Integer) As Integer
    Declare Function HDFree Lib "scwl.dll" (ByVal DiskNum As Integer) As Long
    Declare Function HDUsed Lib "scwl.dll" (ByVal DiskNum As Integer) As Long
    Declare Function HDTotal Lib "scwl.dll" (ByVal DiskNum As Integer) As Long
    Declare Function CLBFind Lib "scwl.dll" (ByVal CL As Integer, ByVal Handle As Integer, ByVal TextSearch As String) As Integer
    
    Declare Function TotLines Lib "cdl36sc.dll" (ByVal MLEHwnd As Integer) As Long
    Declare Sub TextPos Lib "cdl36sc.dll" (ByVal editwnd As Integer, LPPopint As POINTAPI)
    Declare Sub DrawRulerX Lib "cdl36sc.dll" (ByVal picwnd As Integer)
    Declare Sub DrawRulerXT Lib "cdl36sc.dll" (ByVal picwnd As Integer, ByVal LeftMargin As Double, ByVal RightMargin As Double, ByVal RulerWidth As Double, ByVal FromNumber As Integer, ByVal ToNumber As Integer)
    Declare Sub TabStop Lib "cdl36sc.dll" (ByVal picwnd As Integer, ByVal Position As Integer, ByVal TabChar As Integer)
    Declare Sub Paintpic Lib "cdl36sc.dll" (ByVal DHDC As Integer)
    Declare Function ScrollPos Lib "cdl36sc.dll" (ByVal SCrollHwnd As Integer) As Integer

    Declare Function GetWindowsDirectory Lib "Kernel" Alias "getwindowsdirectory" (ByVal p$, ByVal S%) As Integer
    Declare Function GetSystemDirectory Lib "Kernel" (ByVal p$, ByVal S%) As Integer
    Declare Function GetVersion Lib "Kernel" () As Long
    Declare Function sndPlaySound Lib "MMSYSTEM" (ByVal lpszSoundName As String, ByVal uFlags As Integer) As Integer
    Declare Function GetModuleUsage Lib "Kernel" (ByVal hModule As Integer) As Integer
    Declare Sub Yield Lib "Kernel" ()
    Declare Function GetPrivateProfileString Lib "Kernel" (ByVal AppName$, ByVal KeyName$, ByVal keydefault$, ByVal ReturnString$, ByVal NumBytes As Integer, ByVal filename$) As Integer
    Declare Function WritePrivateProfileString Lib "Kernel" (ByVal AppName$, ByVal KeyName$, ByVal keydefault$, ByVal filename$) As Integer
    Declare Function ShowWindow% Lib "User" (ByVal Handle As Integer, ByVal Cmd As Integer)
    'Declare Sub GetCursorPos Lib "User" (lpPoint As POINTAPI)
    Declare Function GetActiveWindow Lib "User" () As Integer
    Declare Function WindowFromPoint Lib "User" (ByVal lpPointY As Integer, ByVal lpPointX As Integer) As Integer
    'Declare Function ShowWindow Lib "User" (ByVal hWnd As Integer, ByVal nCmdShow As Integer) As Integer
    Public Declare Sub GetCursorPos Lib "User" (lpPoint As POINTAPI)
    Declare Function SendMessage Lib "User" (ByVal Hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, ByVal lParam As Any) As Long
        Declare Function BitBlt Lib "GDI" (ByVal destDC%, ByVal X%, ByVal Y%, ByVal w%, ByVal h%, ByVal srchDC%, ByVal srcX%, ByVal srcY%, ByVal rop&) As Integer
    Declare Function GetDesktopWindow Lib "User" Alias "GetDeskTopWindow" () As Integer
    Declare Function GetDC Lib "User" (ByVal Hwnd%) As Integer
    Declare Sub ReleaseDC Lib "User" (ByVal Hwnd%, ByVal hdc%)
    Declare Function StretchBlt% Lib "GDI" (ByVal hdc%, ByVal X%, ByVal Y%, ByVal nWidth%, ByVal nHeight%, ByVal hSrcDC%, ByVal xSrc%, ByVal ySrc%, ByVal nSrcWidth%, ByVal nSrcHeight%, ByVal dwRop&)
    
    Type POINTAPI       ' Stores location of cursor
        X As Integer
        Y As Integer
    End Type
    Public Const CB_FINDSTRING = (WM_USER + 12)
    Public Const LB_FINDSTRING = (WM_USER + 16)

#End If

   Type ConvertPOINTAPI  ' Used by WM_SYSCOMMAND - converts mouse location.
      xy As Long
   End Type


Global Const WM_LBUTTONUP = &H202
Global Const WM_SYSCOMMAND = &H112
Global Const MOUSE_MOVE = &HF012

Global Const SND_SYNC = &H0                 '  play synchronously (default)
Global Const SND_ASYNC = &H1                '  play asynchronously
Global Const SND_NODEFAULT = &H2            '  don't use default sound
Global Const SND_MEMORY = &H4               '  lpszSoundName points to a memory file
Global Const SND_LOOP = &H8                 '  loop the sound until next sndPlaySound
Global Const SND_NOSTOP = &H10              '  don't stop any currently playing sound

Global Const SRCCOPY = &HCC0020 ' (DWORD) dest = source


Type RulerXT
    LM As Integer
    RM As Integer
    Width As Integer
End Type
Global Const ExitWin_Normal = &H1
Global Const ExitWin_Restart = &H2
Global Const ExitWin_Reboot = &H3
Global Const SW_SHOWNOACTIVATE = 4

Type SCFontStruct
    Name As String * 40
    len As Integer
    Size As Integer
    Bold As Boolean
    Italic As Boolean
    Color As Long
    Underline As Boolean
    StrikeOut As Boolean
End Type



Public ShowingTip As Boolean
Type ODI
      Filter As String
      Title As String
      HelpFile As String
      TopicNo As Long
End Type

Type LogonType
    Name As String * 40
    Password As String * 40
    Result As Integer
End Type

Global Const FileDoesExist = 0
Global Const FileDoesNotExist = 1

' Key Codes
Global Const KEY_SHIFT = &H10
Global Const KEY_CONTROL = &H11

Global Const KEY_F1 = &H70
Global Const KEY_F2 = &H71
Global Const KEY_F3 = &H72
Global Const KEY_F4 = &H73
Global Const KEY_F5 = &H74
Global Const KEY_F6 = &H75
Global Const KEY_F7 = &H76
Global Const KEY_F8 = &H77
Global Const KEY_F9 = &H78
Global Const KEY_F10 = &H79
Global Const KEY_F11 = &H7A
Global Const KEY_F12 = &H7B


   Private Type STARTUPINFO
      cb As Long
      lpReserved As String

      lpDesktop As String
      lpTitle As String
      dwX As Long
      dwY As Long
      dwXSize As Long
      dwYSize As Long
      dwXCountChars As Long
      dwYCountChars As Long
      dwFillAttribute As Long
      dwFlags As Long
      wShowWindow As Integer
      cbReserved2 As Integer
      lpReserved2 As Long
      hStdInput As Long
      hStdOutput As Long
      hStdError As Long
   End Type

   Private Type PROCESS_INFORMATION
      hProcess As Long

      hThread As Long
      dwProcessID As Long
      dwThreadID As Long
   End Type

Function DOSPathName(Current As String) As String
Const LenShortPath = 500
Dim Result As Long, ShortPath As String * LenShortPath
#If Win32 Then
    If Not Current = "" Then
        Result = GetShortPathName(Current, ShortPath, LenShortPath)
        DOSPathName = Left$(ShortPath, Result)
    Else
        DOSPathName = ""
    End If
#Else
    DOSPathName = Current
#End If
End Function


Sub RunTillFinished(ToRun As String, Optional CommandLine As Variant)
'Runs a program till it is finished for win 95 / NT
Dim CmdLine$

If Not IsMissing(CommandLine) Then
    CmdLine$ = ToRun & " " & CommandLine
Else
    CmdLine$ = ToRun
End If

#If Win32 Then
    Dim proc As PROCESS_INFORMATION
    Dim start As STARTUPINFO
    Dim Ret&
    ' Initialize the STARTUPINFO structure:
    start.cb = Len(start)

    ' Start the shelled application:
    Ret& = CreateProcessA(0&, CmdLine$, 0&, 0&, 1&, NORMAL_PRIORITY_CLASS, 0&, 0&, start, proc)

    ' Wait for the shelled application to finish:
    Ret& = WaitForSingleObject(proc.hProcess, INFINITE)
    Ret& = CloseHandle(proc.hProcess)
#Else
    Dim rt As Integer
    rt = Shell(CmdLine$, 1)
    Do While GetModuleUsage(rt) > 0
        DoEvents
    Loop
#End If
End Sub




Function PlayResSound(ResID As Integer, Play As Integer) As Integer
Attribute PlayResSound.VB_Description = "Plays A Wav File From A Resource Script"
    Dim Ret As Variant, Play_Type As Integer, SoundBuffer As String
Select Case Play
Case 1
    Play_Type = &H0
Case 2
    Play_Type = &H1
Case 3
    Play_Type = &H2
Case 4
    Play_Type = &H8
Case 5
    Play_Type = &H10
Case Else
    MsgBox "Invalid Play Type", 64, "SC Play Res Sound"
    PlayResSound = 1
    Exit Function
End Select
    On Error Resume Next
    #If Win32 Then
        ' Important: The returned string is converted to Unicode
        SoundBuffer = StrConv(LoadResData(ResID, "ATM_SOUND"), vbUnicode)
    #Else
        SoundBuffer = LoadResData(ResID, "ATM_SOUND")
    #End If
    If Err <> 0 Then
        MsgBox "Problem With Reousrce File." & Chr$(13) & "Please Recompile."
    Else
        Ret = sndPlaySound(SoundBuffer, Play_Type Or SND_NODEFAULT Or SND_MEMORY)
    End If
    ' Important: This function is neccessary for playing sound asynchronously
    DoEvents
End Function

Function PlaySound(filename As String, Play As Integer)
Dim rt As Integer, Play_Type
rt = Fileexist(filename)
If rt <> 0 Then 'File does not exist so exit function
    PlaySound = -1
    Exit Function
End If
Select Case Play
Case 1
    Play_Type = &H0
Case 2
    Play_Type = &H1
Case 3
    Play_Type = &H2
Case 4
    Play_Type = &H8
Case 5
    Play_Type = &H10
Case Else
    MsgBox "Invalid Play Type", 64, "SC Play Sound"
    PlaySound = 1
    Exit Function
End Select
    rt = sndPlaySound(filename, Play_Type)
End Function


Function SystemDirectory() As String
Dim WinPath As String
    WinPath = String(145, Chr(0))
    SystemDirectory = Left(WinPath, GetSystemDirectory(WinPath, Len(WinPath)))

End Function


Function WindowsDirectory() As String
Dim WinPath As String
    WinPath = String(145, Chr(0))
    WindowsDirectory = Left(WinPath, GetWindowsDirectory(WinPath, Len(WinPath)))
End Function


Function WindowsVersion() As String
#If Win32 Then

#Else
    Dim ver As Long, winver As Long
    ver = GetVersion()
    winver = ver And &HFFFF&
    WindowsVersion = Format((winver Mod 256) + ((winver \ 256) / 100), "Fixed")
#End If
End Function


#If Win16 Then
Function DosVersion() As String
Dim ver As Long, dosver As Long
    ver = GetVersion()
    dosver = ver \ &H10000
    DosVersion = Format((dosver \ 256) + ((dosver Mod 256) / 100), "Fixed")
End Function

#End If
Sub CenterForm(NameOfForm As Form)
    Dim FormLeft As Integer
    Dim FormTop As Integer
    FormLeft = (Screen.Width - NameOfForm.Width) / 2
    FormTop = (Screen.Height - NameOfForm.Height) / 2
    NameOfForm.Move FormLeft, FormTop
End Sub

Public Function ShortenPath(LenOfPath As Integer, Path As String) As String
Dim I As Integer, rt, NewPath As String, OldPath As String, UsePath As String
NewPath = Left$(Path, 3) & "..."
OldPath = Mid$(Path, 4)
StartShortenPath:
If Len(OldPath) > (LenOfPath - 6) Then
    OldPath = Mid$(OldPath, 4)
    Do While Not Left$(OldPath, 1) = "\"
        OldPath = Mid$(OldPath, 2)
    Loop
    UsePath = NewPath & OldPath
Else
    UsePath = Path
End If
If Len(UsePath) > LenOfPath Then GoTo StartShortenPath
ShortenPath = UsePath
End Function


Function GetWinIni(Section As String, key As String, Optional DefaultReturn As Variant) As String
Dim RetVal As String, AppName As String, worked As Integer
    RetVal = String$(255, 0)
    worked = GetPrivateProfileString(Section, key, "", RetVal, Len(RetVal), "Win.ini")
    If worked = 0 Then
        If IsMissing(DefaultReturn) Then GetWinIni = "" Else GetWinIni = CStr(DefaultReturn)
    Else
        GetWinIni = Left(RetVal, worked)
    End If
End Function



Public Function MyPath() As String
Dim Path As String
Path = App.Path
If Not Right$(Path, 1) = "\" Then Path = Path & "\"
MyPath = Path
End Function


Public Function StripU(TextToStrip As String)
Dim rt, ToReturn As String, ThisChar As String, I As Integer
For I = 1 To Len(TextToStrip)
    ThisChar = Mid$(TextToStrip, I, 1)
    If ThisChar = "&" Then
    
    Else
        ToReturn = ToReturn & ThisChar
    End If
Next I
StripU = ToReturn
End Function


Public Function WriteMyIni(Section As String, key As String, Setting As String, Optional FileIni As Variant) As Integer
Dim rt, TheInifile As String
'which inifile to use
If IsMissing(FileIni) Then
    TheInifile = IniFile
Else
    TheInifile = CStr(FileIni)
End If

rt = WritePrivateProfileString(Section, key, Setting, TheInifile)
WriteMyIni = rt
End Function



Public Function gs(StringNo As Integer, Optional ToInsert As Variant) As String
Dim ReturnStr As String, ThisString As String, I As Integer, Insert As Boolean
On Error GoTo GSErr
If IsMissing(ToInsert) Then Insert = False Else Insert = True
ThisString = LoadResString(StringNo)
I = InStr(1, ThisString, "%1")
If I > 0 And Insert = True Then
    ReturnStr = Left$(ThisString, I - 1) & ToInsert & Mid$(ThisString, I + 2)
Else
    ReturnStr = ThisString
End If
gs = ReturnStr
GSEP: 'exit point
If ReturnStr = "" Then ReturnStr = "Could Not Load Text"
Exit Function

GSErr:
MsgBox Error$ & Chr$(13) & Chr$(13) & Err, 16, Title$
GoTo GSEP
End Function


Public Function JustPath(ToChange As String) As String
Dim Rtn As String
Rtn = ToChange
If InStr(1, ToChange, "\") > 0 Then
    Do While Not Right$(Rtn, 1) = "\"
        Rtn = Left$(Rtn, Len(Rtn) - 1)
    Loop
Else
    Rtn = ""
End If
JustPath = Rtn

End Function


Function GetBluff(blufflen As Integer) As String
Dim I, bluff_string, this_asc, this_char
bluff_string = ""
For I = 1 To blufflen
    this_asc = Int((200 * Rnd) + 1)
    this_char = Chr$(this_asc)
    bluff_string = bluff_string & this_char
Next I
GetBluff = bluff_string
End Function




Public Sub showtt(Help$)
    Dim lpPoint As POINTAPI ' Cursor Point variable
    Dim Ret As Integer
    If Len(Help$) <> 0 Then
        ' Make sure help form is invisible:
        'tooltips.Hide
        ' Change caption of label:
        'tooltips.Label1.Caption = Help$
        ' Get the cursor position
        Call GetCursorPos(lpPoint)
        ' Offset the form from the cursor
        If Screen.ActiveForm.Top <= Screen.Height - 700 Then
            'tooltips.Top = (lpPoint.Y + 18) * Screen.TwipsPerPixelY
            'tooltips.Left = (lpPoint.X - 2) * Screen.TwipsPerPixelY
        Else
            'tooltips.Top = (lpPoint.Y - 18) * Screen.TwipsPerPixelY
            'tooltips.Left = (lpPoint.X - 2) * Screen.TwipsPerPixelY
        End If
        ' Adjust width and height of form to label
        'tooltips.Width = tooltips.Label1.Width + (4 * Screen.TwipsPerPixelX)
        'tooltips.Height = tooltips.Label1.Height + 4 * Screen.TwipsPerPixelY
        ' Make sure form is on top:
        'tooltips.ZOrder
        ' Show form without the focus:
        'ret = ShowWindow(tooltips.hwnd, SW_SHOWNOACTIVATE)
    Else
        ' Hide the form:
        'tooltips.Hide
    End If
End Sub



Function DiskSpace(Disk As String, diskoption As Integer, ReturnStyle As Integer) As Variant
'This Function deals with Diskspace Free/Used/Total
'within scwl.dll
Dim DiskNo As Integer, Bytes As Long, BytesConversion As Double

'calculate diskno 1 = A, 2 = B and so on
DiskNo = Asc(UCase$(Disk)): DiskNo = DiskNo - 64
If DiskNo < 1 Or DiskNo > 26 Then
    'optional you could put code here to make
    'default drive the C drive
    
    'else exit because invalid drive letter
    'rem following if making default drive
    DiskSpace = -10000
    Exit Function
End If

'bytes will receive the total bytes for the diskoption selected
Select Case diskoption 'this option will be used/free/total
Case 2 'Total Disk Space
    Bytes = HDTotal(DiskNo)
Case 1 'Free Disk Space
    Bytes = HDFree(DiskNo)
Case Else 'used disk space
    Bytes = HDUsed(DiskNo)
End Select

'check to see if drive number exists
If Bytes = -1 Then 'drive is invalid
    DiskSpace = -1
    Exit Function
End If

'returnstyle = bytes,kbytes,mbytes
Select Case ReturnStyle
Case 2 'bytes
    DiskSpace = Bytes 'return bytes as is
Case 1 'mbytes convert bytes to mega bytes
    BytesConversion = Bytes / 1024
    BytesConversion = BytesConversion / 1024
    'place code here to convert bytesconversion to so many decimal places
    DiskSpace = BytesConversion
Case Else 'kbytes convert bytes to kilobytes
    BytesConversion = Bytes / 1024
    'place code here to convert bytesconversion to so many decimal places
    DiskSpace = BytesConversion
End Select
End Function

Function GetMyIni(Section As String, key As String, Optional DefaultReturn As Variant, Optional FileIni As Variant) As String
Dim ReturnString As String, Result As String, TheInifile As String, RetVal As Integer
    
'buffer up return string
ReturnString = String(1000, 0)

'which inifile to use
If IsMissing(FileIni) Then
    TheInifile = IniFile
Else
    TheInifile = CStr(FileIni)
End If

'make call to dll
RetVal = GetPrivateProfileString(Section, key, "", ReturnString, Len(ReturnString), TheInifile)
    
'calculate result and send back
If RetVal <> 0 And Not Left$(ReturnString, RetVal) = "" Then 'worked
    GetMyIni = Left$(ReturnString, RetVal)
Else
    If IsMissing(DefaultReturn) Then GetMyIni = "" Else GetMyIni = DefaultReturn
End If

End Function

Function HelpProc(FormName As Form, Optional TopicNo As Variant) As Boolean
'shows help topic or search box in winhelp
'declare a global declaration for Filehelp in declarations section
Dim Result As Boolean, ThisTopic As Long
'if topicno is not sent assume search
If IsMissing(TopicNo) Then
    Result = Showsearch(FormName.Hwnd, FileHelp)
Else
    ThisTopic = CLng(TopicNo)
    Result = ShowHelp(FormName.Hwnd, FileHelp, ThisTopic)
End If
HelpProc = Result
End Function
Function DecP(ToChange As String, DecPlaces As Integer) As String
'Truncates Decimal Places to Maximum of 4 Decimal Places
Select Case DecPlaces
Case 1
    DecP = Format(ToChange, "#.#0.0")
Case 2
    DecP = Format(ToChange, "#.##0.00")
Case 3
    DecP = Format(ToChange, "#.###0.000")
Case Else
    DecP = Format(ToChange, "#.####0.0000")
End Select
End Function

Public Function OpenProc(Optional Title As Variant, Optional Filter As Variant) As String
'This Procedure Can Be Used To Get A FileName From The
'Open Dialog Box Within scwl.DLL and scwl32.dll
Dim Result As Integer, TheTitle As String, ThePath As String, TheFilter As String, ReturnFile As String

'Set Title
If IsMissing(Title) Then
    TheTitle = "Open..." 'default title
Else
    'if blank String Sent Then A GPF Fault will occur
    If Title = "" Then Title = "Open..."
    TheTitle = Title 'Set Title
End If

'Set Filter
If IsMissing(Filter) Then
    TheFilter = "All Files (*.*)|*.*" 'default filter
Else
    'If TheFilter = "" then a GPF Will Occur
    If Filter = "" Then Filter = "All Files (*.*)|*.*"
    TheFilter = Filter 'Set filter
End If

'Set Up Default Path for Open
ThePath = CurDir 'could be app.path

'Buffer out string to receive filename
ReturnFile = String(255, 0)

'Make call to dll
Result = ShowOpen(TheTitle, TheFilter, ThePath, ReturnFile)
If Result = -1 Then 'user cancelled
    OpenProc = ""
Else ' Then 'user selected a file
    OpenProc = UCase$(Left$(Trim$(ReturnFile), Result)) 'return filename to caller of function
End If
    
End Function

Public Function SaveProc(Optional Title As Variant, Optional Filter As Variant) As String
'This Procedur eCan Be Used To Get A FileName From The
'Open Dialog Box Within scwl.DLL
Dim Result As Integer, TheTitle As String, ThePath As String, TheFilter As String, ReturnFile As String

'Set Title
If IsMissing(Title) Then
    TheTitle = "Save As..." 'default title
Else
    'if blank String Sent Then A GPF Fault will occur
    If Title = "" Then Title = "Save As..."
    TheTitle = Title 'Set Title
End If

'Set Filter
If IsMissing(Filter) Then
    TheFilter = "All Files (*.*)|*.*" 'default filter
Else
    'If TheFilter = "" then a GPF Will Occur
    If Filter = "" Then Filter = "All Files (*.*)|*.*"
    TheFilter = Filter 'Set filter
End If

'Set Up Default Path for Open
ThePath = CurDir 'could be app.path

'Buffer out string to receive filename
ReturnFile = String(255, 0)

'Make call to dll
Result = ShowSave(TheTitle, TheFilter, ThePath, ReturnFile)
If Result = -1 Then 'user selected a file
    SaveProc = "" 'user cancelled or error
Else
    SaveProc = Left$(ReturnFile, Result) 'return filename to caller of function
End If
    

End Function

Public Sub AboutBox(Title As String, Optional Version As Variant, Optional Icon As Variant)
'this sub routine will display an about box from
'scwl.dll
Dim TheIcon As String, TheVersion As String

'about box has default icon so it doesnot need one
'icon is a base ico file
If Not IsMissing(Icon) Then
    If Fileexist(Icon) = True Then
        TheIcon = Icon
    Else
        'if no icon exists must send something in the string else
        'will cause a GPF
        TheIcon = "NoIcon"
    End If
Else
    TheIcon = "NoIcon"
End If
If IsMissing(Version) Then
    TheVersion = CStr(App.Major & "." & App.Minor & "." & App.Revision)
Else
    If Version = "" Then
        TheVersion = CStr(App.Major & "." & App.Minor & "." & App.Revision)
    End If
    TheVersion = Version
End If
'display the about box
    Call ShowAbout(TheIcon, Title, TheVersion)

End Sub

Public Function GetWinHwnd(NameOfForm As Form, TitleOfProg As String) As Long
'this function will get the handle of a window by giving the title
'of the window
Dim Result As Integer
'if blank title (i.e. "" is sent a GPF will occur
If TitleOfProg = "" Then
    GetWinHwnd = -1
    Exit Function
End If

'send call
Result = GetHwnd(NameOfForm.Hwnd, TitleOfProg)

'any number less than 1 indicates it could not find the title
'send result back
GetWinHwnd = Result

End Function

Public Function GetPerc(Number As Double, Optional Total As Variant) As Integer
'this function will calculate a percentage
'both parameters must be sent as double and returns integer

Dim TheTotal As Double, Result As Integer

If IsMissing(Total) Then 'check total is a number
    'default to work out percent is 100
    TheTotal = 100
Else 'convert total to a double
    TheTotal = CDbl(Total)
End If

If Not IsNumeric(Total) Then
    TheTotal = 100
End If

Result = Percent(Number, TheTotal)

End Function
Function UserLogon(Optional Title As Variant) As LogonType
'this function will display a default logon screen
'in scwl.dll.  When a programmer makes this call
'you should process userlogon.result first.  if result = 0
'then the user pressed ok else user pressed cancel

Dim ThisLogon As LogonType, TheTitle As String, ReturnString As String, Result As Integer

'buffer out returnstring
ReturnString = String(255, 0)

'check title
If IsMissing(Title) Then
    TheTitle = "Logon..."
Else
    'cant send blank string (i.e. "" ) else GPF will occur
    If Title = "" Then TheTitle = "Logon..."
    TheTitle = Title
End If

'make call to logon
Result = Logon(TheTitle, ReturnString)
If Result = -1 Then ''user cancelled
    ThisLogon.Result = -1
    UserLogon = ThisLogon
Else
    ThisLogon.Name = Left$(ReturnString, InStr(1, ReturnString, "#") - 1)
    ThisLogon.Password = Mid$(ReturnString, (InStr(1, ReturnString, "#") + 1), Result - (InStr(1, ReturnString, "#")))
    ThisLogon.Result = 0
    UserLogon = ThisLogon
End If

End Function




Public Function LastPath(ExtractFrom As String)
Dim ThisChar As String, RetStr As String, strStore As String
Dim I As Integer
'Returns the last folder/dir from a path statement from ExtractFrom
strStore = ExtractFrom
Do While Len(ExtractFrom) > 1
    ThisChar = Right$(strStore, 1)
    If Not ThisChar = "\" Then
        RetStr = ThisChar & RetStr
        strStore = Left$(strStore, Len(strStore) - 1)
    Else
        Exit Do
    End If
Loop
LastPath = RetStr


End Function

Function AddBack(PathToAddto As String) As String
'adds a backslash '\' to the string passed
Dim rtnstr As String
rtnstr = PathToAddto
If Not Right$(rtnstr, 1) = "\" Then rtnstr = rtnstr & "\"
AddBack = rtnstr
End Function

Public Sub mp(NewMousePointer As Integer)
DoEvents
Select Case NewMousePointer
Case 0 To 15
    Screen.MousePointer = NewMousePointer
Case 99
    Screen.MousePointer = NewMousePointer
Case Else
    Screen.MousePointer = 0
End Select
End Sub

Public Function JustExtension(GetExtFrom As String) As String
Dim RetStr As String, I As Integer, ThisChar As String, ExtensionText As String
ExtensionText = GetExtFrom
If InStr(1, GetExtFrom, ".") > 0 Then
    For I = 1 To Len(GetExtFrom)
        ThisChar = Right$(ExtensionText, 1)
        ExtensionText = Left$(ExtensionText, Len(ExtensionText) - 1)
        If ThisChar = "." Then
            Exit For
        Else
            RetStr = ThisChar & RetStr
        End If
    Next I
    JustExtension = RetStr
Else
    JustExtension = ""
End If

End Function


Public Function JustFileName(FName As String) As String
Dim I As Integer, ThisFile As String
On Local Error Resume Next
ThisFile = FName
Do While InStr(1, ThisFile, "\") > 0
    ThisFile = Mid$(ThisFile, 2)
Loop
JustFileName = ThisFile
End Function

Public Function GetMyReg(Section, key, Optional DefaultReturn As Variant, Optional FileIni As Variant) As Variant
'buffer up return string
Dim ReturnString As String, TheInifile As String

'which inifile to use
If IsMissing(FileIni) Then
    TheInifile = IniFile
Else
    TheInifile = CStr(FileIni)
End If

If Win95RegBase = "" Then 'use VB call to reg location "[HKEY_CURRENT_USER\Software\VB and VBA Program Settings\"
    If IsMissing(DefaultReturn) Then
        ReturnString = GetSetting(Left$(TheInifile, (InStr(1, TheInifile, ".") - 1)), Section, key)
    Else
        ReturnString = GetSetting(Left$(TheInifile, (InStr(1, TheInifile, ".") - 1)), Section, key)
        If ReturnString = "" Then ReturnString = CStr(DefaultReturn)
    End If
Else 'use win api calls to proper location
    
End If
'calculate result and send back
GetMyReg = ReturnString
    
End Function

Public Function WriteMyReg(Section As String, key As String, Setting As String, Optional FileIni As Variant) As Integer
Dim TheInifile As String

'which inifile to use
If IsMissing(FileIni) Then
    TheInifile = IniFile
Else
    TheInifile = CStr(FileIni)
End If

On Error Resume Next
Call SaveSetting(Left$(TheInifile, (InStr(1, TheInifile, ".") - 1)), Section, key, Setting)
If Err <> 0 Then
    WriteMyReg = 0
    MsgBox "Error Writing to System Registry", 64, Title$
    Exit Function
End If
WriteMyReg = Len(Setting)
End Function

Public Function IsDrive(Drive As String) As Boolean
'Purpose - See If Drive is a valid Drive

'Returns - True if Drive Exists
'        - False if Drive Does Not Exist

'caution if floppy or cd then returns false if no disk in drive


Dim TempDrive As String, DriveNum As Integer, Result As Long

'Strip Drive To First Character Using JustDrive
TempDrive = Left$(JustDrive(Drive), 1)

'Set DriveNum for Call To DLL
DriveNum = Asc(TempDrive)
If DriveNum < 65 Or DriveNum > 90 Then
    DriveNum = 68
End If
DriveNum = DriveNum - 64 '(with HDCalls A = 1; B = 2; C = 3; etc)

'make call
Result = HDFree(DriveNum)

'process result
If Result = -1 Then
    IsDrive = False 'drive does not exist
Else
    IsDrive = True 'drive does exist
End If
End Function

Public Function JustDrive(Path As String) As String
Dim Num As Integer, TempDrive As String
TempDrive = Left$(UCase$(Path), 1)
Num = Asc(TempDrive)
If Num < 65 Or Num > 90 Then
    Num = 68 'default c for C:
End If
JustDrive = Chr$(Num) & ":" 'send back result

End Function


Public Function StripSpaces(ByVal ToStripFrom As String) As String
Do While InStr(1, ToStripFrom, " ") > 0
    ToStripFrom = Left$(ToStripFrom, InStr(1, ToStripFrom, " ") - 1) & Mid$(ToStripFrom, InStr(1, ToStripFrom, " ") + 1)
Loop
StripSpaces = ToStripFrom
End Function

Public Function NotBack(Path As String) As String
If Right$(Path, 1) = "\" Then
    Path = Left$(Path, Len(Path) - 1)
End If
NotBack = Path
End Function

Public Function Inc(X As Integer) As Integer
On Error GoTo IncErr
X = X + 1

IncEP: 'exit point
Inc = X
Exit Function

IncErr:
X = 0
GoTo IncEP
End Function
Public Function Dec(X As Integer) As Integer
On Error GoTo DecErr
X = X - 1

DecEP: 'exit point
Dec = X
Exit Function

DecErr:
X = 0
GoTo DecEP
End Function


Public Function ReverseText(TextToReverse As String) As String
Dim I As Long, RetStr As String, ThisChar As String
For I = 0 To Len(TextToReverse)
    ThisChar = Left$(TextToReverse, 1)
    TextToReverse = Mid$(TextToReverse, 2)
    RetStr = ThisChar & RetStr
Next I
ReverseText = RetStr
End Function

Public Function FindInList(Hwnd As Long, Text As String) As Long
On Error GoTo FindInListErr
If Text = "" Then
    FindInList = -1
    Exit Function
End If
FindInList = SendMessage(Hwnd, LB_FINDSTRING, -1, ByVal CStr(Text))
FindInListEP: 'Exit Point
Exit Function
FindInListErr: 'err handler
FindInList = -1
GoTo FindInListErr
End Function
Public Function FindInCombo(Hwnd As Long, Text As String) As Long
On Error GoTo FindInComboErr
If Text = "" Then
    FindInCombo = -1
    Exit Function
End If
FindInCombo = SendMessage(Hwnd, CB_FINDSTRING, -1, ByVal CStr(Text))
FindInComboEP: 'Exit Point
Exit Function
FindInComboErr: 'err handler
FindInCombo = -1
GoTo FindInComboErr
End Function
